import { ChainGunLink } from './ChainGunLink';
import { GunGraph } from './Graph/GunGraph';
interface ChainGunOptions {
    peers?: string[];
    graph?: GunGraph;
    WS?: typeof WebSocket;
}
/**
 * Main entry point for ChainGun
 *
 * Usage:
 *
 *   const gun = new ChainGun({ peers: ["https://notabug.io/gun"]})
 *   gun.get("nab/things/59382d2a08b7d7073415b5b6ae29dfe617690d74").on(thing => console.log(this))
 */
export declare class ChainGun {
    graph: GunGraph;
    private LinkClass;
    private _opt;
    constructor(opt?: ChainGunOptions, LinkClass?: typeof ChainGunLink);
    /**
     * Set ChainGun configuration options
     *
     * @param options
     */
    opt(options: ChainGunOptions): this;
    /**
     * Traverse a location in the graph
     *
     * @param key Key to read data from
     * @param cb
     * @returns New chain context corresponding to given key
     */
    get(soul: string, cb?: GunMsgCb): ChainGunLink;
}
export {};
