export declare class MiddlewareSystem<T, U = undefined, V = undefined> {
    name: string;
    private _middlewareFunctions;
    constructor(name?: string);
    /**
     * Register middleware function
     *
     * @param middleware The middleware function to add
     */
    use(middleware: (a: T, b?: U, c?: V) => T | undefined): this | undefined;
    /**
     * Unregister middleware function
     *
     * @param middleware The middleware function to remove
     */
    unuse(middleware: (a: T, b?: U, c?: V) => T | undefined): this;
    /**
     * Process values through this middleware
     * @param a Required, this is the value modified/passed through each middleware fn
     * @param b Optional extra argument passed to each middleware function
     * @param c Optional extra argument passed to each middleware function
     */
    process(a: T, b?: U, c?: V): Promise<T | undefined>;
}
