interface GunNodeState {
    [key: string]: number;
}
interface GunNode {
    _: {
        '#': string;
        '>': GunNodeState;
    };
    [key: string]: any;
}
interface GunGraphData {
    [key: string]: GunNode | undefined;
}
interface GunMsg {
    '#'?: string;
    '@'?: string;
    get?: {
        '#': string;
    };
    put?: GunGraphData;
    ack?: number | boolean;
    err?: any;
}
declare type GunValue = object | string | number | boolean | null;
declare type GunChainOptions = any;
declare type SendFn = (msg: GunMsg) => void;
declare type GunOnCb = (node: GunValue | undefined, key?: string) => void;
declare type GunMsgCb = (msg: GunMsg) => void;
declare type GunNodeListenCb = (node: GunNode | undefined) => void;
interface PathData {
    souls: string[];
    value: GunValue | undefined;
    complete: boolean;
}
declare type ChainGunMiddleware = (updates: GunGraphData, existingGraph: GunGraphData) => GunGraphData | undefined | Promise<GunGraphData | undefined>;
declare type ChainGunMiddlewareType = 'read' | 'write';
